#!/bin/sh
# Download all scripts into $temp_path, choose what needs to install and install it
# Written: Georgi Georgiev - gdgeorgiev@hpe.com
# Date: 04.02.2016

# Set proxy url / port
proxy_url='http-proxy-ha.e-ssi.net:8080';
export https_proxy="$proxy_url"

# scripts url
scripts_url='https://webdav.intranet.eon-it.com/eoi/software/scripts';

# temp_path
temp_path='/webdienste/transfer/autoinstall';
b_script='baseinstall.sh';
t_script='tomcat.sh';
j_script='jboss.sh';
m_script='mysql.sh';

# Download scripts
down_script () {

if [ !-d "$temp_path" ]; then
mkdir -p "$temp_path";
fi

if [ -d $temp_path ]; then
    cd $temp_path
    wget --no-check-certificate --timeout=5 $scripts_url/$b_script;
    wget --no-check-certificate --timeout=5 $scripts_url/$t_script;
    wget --no-check-certificate --timeout=5 $scripts_url/$j_script;
    wget --no-check-certificate --timeout=5 $scripts_url/$m_script;
fi

}

# Choose install type
install_type () {

echo 'What do you want to do, today?';
echo '------------------------------';
echo '1. Install baseinstall';
echo '2. Install Jboss';
echo '3. Install Tomcat';
echo '4. Install MySQL';
echo '5. Install All 4 - baseinstall, jboss, tomcat, mysql';
echo 
read -p 'Choose: ' choice;

if [[ ! -z $choice ]]; then

if [ "$choice" == '1' ]; then
echo "Running KIFT install script $b_script";
cd $temp_path;
sh $b_script
exit 0;
fi

if [ "$choice" == '2' ]; then
echo "Running Tomcat install script $t_script";
cd $temp_path;
sh $t_script
exit 0;
fi

if [ "$choice" == '3' ]; then
echo "Running Jboss install script.";
cd $temp_path;
sh $j_script
exit 0;
fi

if [ "$choice" == '4' ]; then
echo "Running MySQL install script.";
cd $temp_path;
sh $m_script
exit 0;
fi


if [ "$choice" == '5' ]; then
echo "Running KIFT install script $b_script";
cd $temp_path;
sh $b_script;
echo "Running Tomcat install script $t_script";
sh $t_script;
echo "Running Jboss install script $j_script";
sh $j_script;
echo "Running MySQL install script $m_script";
sh $m_script;
exit 0;
fi

fi

}

clean_obsolete () {

if [[ -d $temp_path ]]; then
echo "rm -rf $temp_path"
fi

}

# Main function
main () {
down_script;
install_type;
clean_obsolete;
}
main;

